/*
#
# This attempts to load and use the drv2.so.6.0 from realplay
#
# $Id:$
#
# Copyright (C) 2002 Kees Cook
# kees@outflux.net, http://outflux.net/
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html
#
*/

#include <dlfcn.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "codec.h"

unsigned char init_str[]={
0x0b, 0x00, 0x40, 0x01, 0xf0, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x74, 0x40, 0x38, 0x88, 0x00, 0x01, 
0x01, 0x00, 0x00, 0x00, 0x01, 0x10, 0x10, 0x20, 
0x90, 0x70, 0x0c, 0x08, 0x78, 0x86, 0x0c, 0x08, 
0x68, 0xc8, 0xff, 0xbf, 0xa9, 0x72, 0x72, 0x40, 
0xa0, 0x90, 0x0c, 0x08, 0x00, 0x00, 0x00, 0x00, 
0x68, 0xc8, 0xff, 0xbf, 0x07, 0x65, 0x72, 0x40, 
0x78, 0x86, 0x0c, 0x08, 0x00, 0x00, 0x00, 0x00, 
0xa4, 0x01, 0x00, 0x00, 0xbd, 0x64, 0x72, 0x40, 
0x6c, 0x71, 0x74, 0x40, 0xb0, 0x5c, 0x0c, 0x08, 
0x90, 0x70, 0x0c, 0x08, 0xa8, 0xd8, 0xff, 0xbf, 
0xfe, 0x08, 0x72, 0x40, 0x00, 0x0c, 0x00, 0x00, 
0xa8, 0xd8, 0xff, 0xbf, 
};

struct hive_t
{
        char big[0x100];
};

struct free_t
{
        char big[0x180];
};

struct custom_t
{
        char big[0x26];
};

char * pn_error(unsigned int errnum)
{
        static char buf[128];

        switch (errnum)
        {
        case 0x80004001:
                return "Not Implemented";
        case 0x8007000E:
                return "Out of Memory";
        case 0x80070057:
                return "Invalid Argument";
        case 0x80004002:
                return "No Interface";
        case 0x80004003:
                return "Bad Pointer";
        case 0x80070006:
                return "Bad? Handle";
        case 0x80004004:
                return "Abort";
        case 0x80004005:
                return "Fail";
        case 0x80070005:
                return "Access Denied";
        case 0x0:
                return "Success";
        default:
                sprintf(buf,"Unknown error: 0x%x",errnum);
                return buf;
        }
}

// prototypes...
unsigned int (*rv20_init)(struct init_t * info, void ** handle);
unsigned int (*rv20_hive)(unsigned int * info, void * handle);
unsigned int (*rv20_free)(void * handle);
unsigned int (*rv20_custom)(struct custom_t);
unsigned int (*rv20_transform)
              (
                unsigned int input_size,  // +8       read size?
                unsigned int output_size,  // +0       write size?
                unsigned char * input,// +10      pointer test, readable
                unsigned char * output, // +14      pointer test, writable
                void * handle  // +18 esi  source? handle?
              );

/*
  
three struct:
0:...
8: kept
10: check for low byte==1
  
  
  
 */

int init_callback(void)
{
        printf("%s: oh shit\n",__FUNCTION__);
        return 0;
}

/*
void __pure_virtual()
{
        printf("__pure_virtual called\n");
}
*/

int main()
{
        // libs
        void * rv20;
        // temp
        unsigned int result;

        // init stuff
        void * handle;
        struct init_t * init_data;

        // hive stuff
        unsigned int thingy;

        // xform stuff
        FILE * stream;
        unsigned char input[65536];
        unsigned char output[65536];
        unsigned int in_size, out_size;

        if (!(rv20=dlopen("./drv2.so.6.0",RTLD_LAZY)))
        {
                fprintf(stderr,"dlopen: %s\n",dlerror());
                return(1);
        }
                                
        if (!((void*)rv20_init=dlsym(rv20,"RV20toYUV420Init")))
        {
                fprintf(stderr,"dlsym('%s'): %s\n",
                                "RV20toYUV420Init",dlerror());
                return(1);
        }

        if (!((void*)rv20_free=dlsym(rv20,"RV20toYUV420Free")))
        {
                fprintf(stderr,"dlsym('%s'): %s\n",
                                "RV20toYUV420Free",dlerror());
                return(1);
        }

        if (!((void*)rv20_custom=dlsym(rv20,"RV20toYUV420CustomMessage")))
        {
                fprintf(stderr,"dlsym('%s'): %s\n",
                                "RV20toYUV420CustomMessage",dlerror());
                return(1);
        }

        if (!((void*)rv20_hive=dlsym(rv20,"RV20toYUV420HiveMessage")))
        {
                fprintf(stderr,"dlsym('%s'): %s\n",
                                "RV20toYUV420HiveMessage",dlerror());
                return(1);
        }

        if (!((void*)rv20_transform=dlsym(rv20,"RV20toYUV420Transform")))
        {
                fprintf(stderr,"dlsym('%s'): %s\n",
                                "RV20toYUV420Transform",dlerror());
                return(1);
        }

        printf("Loaded.\n");

        init_data=malloc(sizeof(*init_data));

        printf("init_data: %x\n",(unsigned int)init_data);
        printf("rv20_init: %x\n",(unsigned int)rv20_init);
        printf("rv20_hive: %x\n",(unsigned int)rv20_hive);
        printf("rv20_free: %x\n",(unsigned int)rv20_free);

        memset(init_data,0,sizeof(init_data));
        //memcpy(init_data,init_str,sizeof(*init_data));
        init_data->bee=0x000b;
        init_data->width=320;
        init_data->height=240;
        init_data->h_id=0x000020101001;
        init_data->callback=init_callback;


        printf("Calling init...\n");
        result=rv20_init(init_data,&handle);
        printf("\tgot %s (handle: %x)\n",pn_error(result),(unsigned int)handle);



        thingy=0;
        printf("Calling hive...(thingy: 0x%x)\n",thingy);
        result=rv20_hive(&thingy,handle);
        printf("\tgot %s\n",pn_error(result));


        if (!(stream=fopen("stream.dump","r")))
        {
                perror("stream.dump");
                exit(1);
        }


        if (fread(input,65536,1,stream)!=1)
        {
                perror("fread");
                exit(1);
        }

        printf("Calling transform...\n");
        in_size=out_size=65536;
        memset(output,0,out_size);
        result=rv20_transform(in_size,out_size,input,output,handle);
        printf("\tgot %s\n",pn_error(result));


        fclose(stream);

        printf("Calling free...\n");
        result=rv20_free(handle);
        printf("\tgot %s\n",pn_error(result));

        printf("Done.\n");

        dlclose(rv20);
        return 0;
}
