/*
#
# A stub replacement for drv2.so.6.0
#
# $Id:$
#
# Copyright (C) 2002 Kees Cook
# kees@outflux.net, http://outflux.net/
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html
#
*/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#include "codec.h"


int _init()
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        /*
        printf("320x240: %xx%x\n",320,240);
        */
        return 0;
}

int _fini()
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        return 0;
}

void dumpmem(char * name, void * addr, int len, int printable)
{
        int i;
        int loc=0;
        unsigned char * address=(unsigned char *)addr;

        if (!address)
        {
                fprintf(stderr,"%s: NULL\n",name);
                return;
        }

        fprintf(stderr,"%s:\n",name);

        for (i=0;i<len;i++)
        {
                if (printable && isprint(address[i]))
                        fprintf(stderr,"%c ",address[i]);
                else
                        fprintf(stderr,"0x%02x, ",address[i]);
                loc++;

                if (loc==8)
                {
                        fprintf(stderr,"\n");
                        loc=0;
                }
        }
        if (loc!=0)
                fprintf(stderr,"\n");
}

int RV20toYUV420CustomMessage(void * one, void * two,
                              void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}

void RV20toYUV420Free(void * one, void * two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);

        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);

        return;
}

// appears to be void from disass
int RV20toYUV420HiveMessage(unsigned int * one, unsigned int handle)
{
        fprintf(stderr,"%s: one: %x\n",__FUNCTION__,
                        (unsigned int)one);
        fprintf(stderr,"%s: handle: %x\n",__FUNCTION__,
                        (unsigned int)handle);

        if (one) fprintf(stderr,"*one: %x\n",*one);

        {
                int i;
                for (i=0;i<100/4;i++)
                        printf("int one[%02d]: 0x%x\n",i,one[i]);
                dumpmem("one",one,100,0);
        }

        return 0;
}

unsigned int master_handle=0xBEEF0000;

// This appears to return void from the disassembly
unsigned int RV20toYUV420Init(unsigned int * info, unsigned int * handle)
{
        struct init_t * init;

        /*
        fprintf(stderr,"%s: 0x%x\n",__FUNCTION__,(unsigned int)RV20toYUV420Init);
        fprintf(stderr,"%s: info: 0x%x\n",__FUNCTION__,
                        (unsigned int)info);
        fprintf(stderr,"%s: handle: 0x%x\n",__FUNCTION__,
                        (unsigned int)handle);

        if (handle) fprintf(stderr,"*handle: 0x%x\n",*handle);
        if (info)
        {
                unsigned short * ptr=(void*)info;
                int i;
                for (i=0;i<100/2;i++)
                        fprintf(stderr,"word info[%02d]: 0x%012x\n",i,ptr[i]);
        }
        */
        init=(void*)info;

        printf("%s: unknown short[00]: 0x%04x\n",__FUNCTION__,init->bee);
        printf("%s: dimensions: %dx%d\n",__FUNCTION__,init->width,init->height);
        printf("%s: unknown short[01]: 0x%04x\n",__FUNCTION__,init->zero);
        printf("%s: callback: 0x%x\n",__FUNCTION__,(unsigned int)init->callback);
        /*
        {
                int i;
                for (i=0;i<4;i++)
                        printf("unknown short[%02d]: 0x%x\n",i+2,init->unknown[i]);
        }
        */
        printf("%s: H.263 ID: 0x%x\n",__FUNCTION__,init->h_id);

        /*
        if (info)
        {
                int i;
                for (i=0;i<11;i++)
                        fprintf(stderr,"int info[%02d]: 0x%012x\n",i,info[i]);
        }

        dumpmem("info",info,100,0);

        if (init->callback)
        {
                int cool=0;
                printf("calling...\n");
                cool=init->callback();
                printf("back: %d\n",cool);
        }
        */

        master_handle++;
        if (handle) *handle=master_handle;

//        if (master_handle==0xbeef0002) abort();

        return 0;
}

int RV20toYUV420_RN_FRU_Free(void * one, void * two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}

int RV20toYUV420_RN_FRU_GetFrame(void * one, void * two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}

int RV20toYUV420_RN_FRU_Init(void * one, void * two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}

int RV20toYUV420_RN_FRU_Setup(void * one, void * two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}

int RV20toYUV420Transform(void * one, void *two,
                void * three, void * four)
{
        fprintf(stderr,"%s: called\n",__FUNCTION__);
        fprintf(stderr,"%s: one: %x two: %x three: %x four: %x\n",__FUNCTION__,
                        (unsigned int)one,(unsigned int)two,(unsigned int)three,(unsigned int)four);
        dumpmem("one",one,4,1);
        dumpmem("two",two,4,1);
        dumpmem("three",three,4,1);
        dumpmem("four",four,4,1);
        return 1;
}


